package com.wd.workoffice.ui.activity.bat;

import android.content.DialogInterface;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.View;
import android.widget.EditText;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.alibaba.fastjson.JSON;
import com.bigkoo.pickerview.listener.OnTimeSelectListener;
import com.chad.library.adapter.base.BaseQuickAdapter;
import com.qmuiteam.qmui.widget.dialog.QMUIDialog;
import com.wd.workoffice.R;
import com.wd.workoffice.app.WorkToolBarActivity;
import com.wd.workoffice.bean.ProductBean;
import com.wd.workoffice.ui.adapter.StoreCarAdapter;
import com.wd.workoffice.util.DialogUtils;
import com.wd.workoffice.util.PickTimeUtils;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;
import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import flexible.xd.android_base.utils.TimeUtils;

/**
 * 商店-销售-产品-确认订单
 * author : flexible
 * email : lgd19940421@163.com
 * github: https://github.com/FlexibleXd
 **/
public class StoreSaleConfirmActivity extends WorkToolBarActivity {

    @BindView(R.id.tv_num)
    TextView tvNum;
    @BindView(R.id.tv_price)
    TextView tvPrice;
    @BindView(R.id.tv_ok)
    TextView tvOk;
    @BindView(R.id.ll_bottom)
    RelativeLayout llBottom;
    @BindView(R.id.rv_pro)
    RecyclerView rvPro;
    @BindView(R.id.tv_set)
    TextView tvSet;
    @BindView(R.id.rl_set)
    RelativeLayout rlSet;
    @BindView(R.id.tv_time)
    TextView tvTime;
    @BindView(R.id.rl_time)
    RelativeLayout rlTime;
    @BindView(R.id.et_address)
    EditText etAddress;
    @BindView(R.id.et_input1)
    EditText etInput1;
    @BindView(R.id.tv_input1)
    TextView tvInput1;
    @BindView(R.id.et_input2)
    EditText etInput2;
    @BindView(R.id.tv_input2)
    TextView tvInput2;
    @BindView(R.id.et_input3)
    EditText etInput3;
    @BindView(R.id.tv_input3)
    TextView tvInput3;
    @BindView(R.id.et_input4)
    EditText etInput4;
    @BindView(R.id.tv_input4)
    TextView tvInput4;
    @BindView(R.id.et_input5)
    EditText etInput5;
    @BindView(R.id.tv_input5)
    TextView tvInput5;
    private List<ProductBean.RecordsBean> proList;
    private StoreCarAdapter proAdapter;
    private QMUIDialog.MenuDialogBuilder setDialog;
    private String[] setArray = new String[]{"钢控", "锆碳"};

    @Override
    protected void initView() {
        ButterKnife.bind(this);
        rvPro.setLayoutManager(new LinearLayoutManager(this, RecyclerView.VERTICAL, false));
        setDialog = DialogUtils.listDialog(this);
        setDialog.addItems(setArray, new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                tvSet.setText(setArray[which]);
                dialog.dismiss();
            }
        });
    }


    @Override
    protected void initData() {
        proList = new ArrayList<>();
        proAdapter = new StoreCarAdapter(R.layout.item_confirm_pro, proList, 1);
        proAdapter.bindToRecyclerView(rvPro);
        proList.addAll(JSON.parseArray(getIntent().getStringExtra("pro"), ProductBean.RecordsBean.class));
    }


    @Override
    protected void initEvent() {
        addNumListener(etInput1, tvInput1);
        addNumListener(etInput2, tvInput2);
        addNumListener(etInput3, tvInput3);
        addNumListener(etInput4, tvInput4);
        addNumListener(etInput5, tvInput5);
        proAdapter.setOnItemChildClickListener(new BaseQuickAdapter.OnItemChildClickListener() {
            @Override
            public void onItemChildClick(BaseQuickAdapter adapter, View view, int position) {
            }
        });
    }

    /**
     * 添加字数监听器
     *
     * @param et
     * @param tv
     */
    private void addNumListener(EditText et, TextView tv) {
        et.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {

            }

            @Override
            public void afterTextChanged(Editable s) {
                tv.setText(s.length() + "/140");
            }
        });
    }

    @Override
    protected int layoutId() {
        return R.layout.activity_bat_sale_confirm;
    }


    @OnClick({R.id.tv_ok, R.id.rl_set, R.id.rl_time})
    public void onViewClicked(View view) {
        switch (view.getId()) {
            case R.id.tv_ok:
                break;
            case R.id.rl_set:
                setDialog.show();
                break;
            case R.id.rl_time:
                PickTimeUtils.showPickThree(StoreSaleConfirmActivity.this, new OnTimeSelectListener() {
                    @Override
                    public void onTimeSelect(Date date, View v) {
                        tvTime.setText(TimeUtils.date2String(date, new SimpleDateFormat("yyyy-MM-dd")));
                    }
                }).show();
                break;
        }
    }
}
