package com.wd.workoffice.ui.fg;

import android.os.Bundle;

import com.chad.library.adapter.base.BaseQuickAdapter;
import com.wd.workoffice.R;
import com.wd.workoffice.app.WorkBaseFg;
import com.wd.workoffice.bean.SaleOrderBean;
import com.wd.workoffice.contract.SaleSaleContract;
import com.wd.workoffice.presenter.SaleSalePresenter;
import com.wd.workoffice.ui.adapter.SaleOutAdapter;
import com.wd.workoffice.ui.adapter.SaleSaleAdapter;
import com.wd.workoffice.util.WorkUtils;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import androidx.annotation.Nullable;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;
import butterknife.BindView;
import butterknife.ButterKnife;


/**
 * author : flexible
 * email : lgd19940421@163.com
 * github: https://github.com/FlexibleXd
 **/
public class SaleOutFragment extends WorkBaseFg implements SaleSaleContract.View {

    @BindView(R.id.rv_data)
    RecyclerView rvData;
    private String state;
    private SaleSalePresenter saleSalePresenter;
    private Map<String, Object> param;
    private List<SaleOrderBean> orderList;
    private SaleOutAdapter orderAdapter;
    private int page = 1;
    private String identity;
    @Override
    protected void initView() {
        ButterKnife.bind(this, getContentView());
        saleSalePresenter = new SaleSalePresenter();
        saleSalePresenter.onAttach(this);
        rvData.setLayoutManager(new LinearLayoutManager(getActivity(), RecyclerView.VERTICAL, false));
    }


    @Override
    protected void initData() {
        orderList = new ArrayList<>();
        orderAdapter = new SaleOutAdapter(R.layout.item_sale_out, orderList);
        orderAdapter.bindToRecyclerView(rvData);
        param = WorkUtils.pageKey();
        param.put("orderStatus", state);
        param.put("current", page);
        param.put("identity",  identity);
        saleSalePresenter.getOutOrder(param);
    }


    @Override
    protected void initEvent() {
        orderAdapter.setOnLoadMoreListener(new BaseQuickAdapter.RequestLoadMoreListener() {
            @Override
            public void onLoadMoreRequested() {
                param.put("current", page);
                saleSalePresenter.getOutOrder(param);
            }
        }, rvData);
    }

    @Override
    protected int layoutId() {
        return R.layout.fg_sale_sale;
    }

    @Override
    public void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        Bundle arguments = getArguments();
        if (arguments != null) {
            state = arguments.getString("state");
            identity = arguments.getString("identity");
        }
    }

    @Override
    public void saleList(List<SaleOrderBean> dataList) {

    }

    @Override
    public void outList(List<SaleOrderBean> dataList) {
        if (page == 1) {
            orderList.clear();
            orderList.addAll(dataList);
            orderAdapter.notifyDataSetChanged();
            orderAdapter.loadMoreComplete();
        } else {
            orderAdapter.loadMoreComplete();
            orderList.addAll(dataList);
            orderAdapter.notifyDataSetChanged();
        }
        if (dataList.size() == 0) {
            orderAdapter.loadMoreEnd();
        } else {
            page++;
        }
    }

    @Override
    public void insideList(List<SaleOrderBean> dataList) {

    }

    @Override
    public void supplierList(List<SaleOrderBean> dataList) {

    }
}
